function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { renderless, api } from "@xmweb-ui/vue-renderless/date-panel/vue";
import { defineComponent, $prefix, directive, $props, setup as _setup } from "@xmweb-ui/vue-common";
import { language } from "@xmweb-ui/vue-locale";
import Clickoutside from "@xmweb-ui/vue-renderless/common/deps/clickoutside";
import Time from "@xmweb-ui/vue-time";
import DateTable from "@xmweb-ui/vue-date-table";
import YearTable from "@xmweb-ui/vue-year-table";
import MonthTable from "@xmweb-ui/vue-month-table";
import Input from "@xmweb-ui/vue-input";
import Button from "@xmweb-ui/vue-button";
import { iconDoubleRight, iconDoubleLeft, iconChevronLeft, iconChevronRight, iconChevronDown, iconChevronUp } from "@xmweb-ui/vue-icon";
import Popup from "@xmweb-ui/vue-popup";
import "@xmweb-ui/vue-theme/input/index.css";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import "@xmweb-ui/vue-theme/date-panel/index.css";
var __vue2_script = defineComponent({
  name: $prefix + "DatePanel",
  directives: directive({
    Clickoutside
  }),
  components: {
    TimePicker: Time,
    YearTable,
    MonthTable,
    DateTable,
    XmInput: Input,
    XmButton: Button,
    XmPopup: Popup,
    IconDoubleRight: iconDoubleRight(),
    IconDoubleLeft: iconDoubleLeft(),
    IconChevronLeft: iconChevronLeft(),
    IconChevronRight: iconChevronRight(),
    IconChevronDown: iconChevronDown(),
    IconChevronUp: iconChevronUp()
  },
  props: _extends({}, $props, {
    emitter: Object,
    step: {
      type: Object,
      default: function _default() {
        return {
          hour: 1,
          minute: 1,
          second: 1
        };
      }
    },
    showWeekNumber: {
      type: Boolean,
      default: false
    },
    formatWeeks: Function
  }),
  emits: ["pick", "select-change", "dodestroy"],
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true,
      extendOptions: {
        language
      }
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("transition", {
    attrs: {
      "name": "xm-zoom-in-top"
    },
    on: {
      "after-enter": _vm.handleEnter,
      "after-leave": _vm.handleLeave
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.visible,
      expression: "state.visible"
    }],
    staticClass: "xm-picker-panel xm-date-picker xm-popper",
    class: [{
      "has-sidebar": _vm.slots.sidebar || _vm.state.shortcuts,
      "has-time": _vm.state.showTime
    }, _vm.state.popperClass]
  }, [_c("div", {
    staticClass: "xm-picker-panel__body-wrapper"
  }, [_vm._t("sidebar"), _vm.state.shortcuts ? _c("div", {
    staticClass: "xm-picker-panel__sidebar"
  }, _vm._l(_vm.state.shortcuts, function(shortcut, key) {
    return _c("button", {
      key,
      staticClass: "xm-picker-panel__shortcut",
      attrs: {
        "type": "button"
      },
      on: {
        "click": function click($event) {
          return _vm.handleShortcutClick(shortcut);
        }
      }
    }, [_vm._v(" " + _vm._s(shortcut.text) + " ")]);
  }), 0) : _vm._e(), _c("div", {
    staticClass: "xm-picker-panel__body"
  }, [_vm.state.showTime ? _c("div", {
    staticClass: "xm-date-picker__time-header"
  }, [_c("span", {
    staticClass: "xm-date-picker__editor-wrap"
  }, [_c("xm-input", {
    attrs: {
      "placeholder": _vm.t("ui.datepicker.selectDate"),
      "model-value": _vm.state.visibleDate,
      "size": "small"
    },
    on: {
      "update:modelValue": function updateModelValue(val) {
        return _vm.state.userInputDate = val;
      },
      "change": _vm.handleVisibleDateChange
    }
  })], 1), _c("span", {
    directives: [{
      name: "clickoutside",
      rawName: "v-clickoutside",
      value: _vm.handleTimePickClose,
      expression: "handleTimePickClose"
    }],
    staticClass: "xm-date-picker__editor-wrap"
  }, [_c("xm-input", {
    ref: "input",
    attrs: {
      "placeholder": _vm.t("ui.datepicker.selectTime"),
      "model-value": _vm.state.visibleTime,
      "size": "small"
    },
    on: {
      "focus": function focus($event) {
        _vm.state.timePickerVisible = true;
      },
      "update:modelValue": function updateModelValue(val) {
        return _vm.state.userInputTime = val;
      },
      "change": _vm.handleVisibleTimeChange
    }
  }), _vm.state.timePickerVisible ? _c("time-picker", {
    ref: "timepicker",
    attrs: {
      "step": _vm.step,
      "time-arrow-control": _vm.state.arrowControl,
      "show": _vm.state.timePickerVisible,
      "value": _vm.state.date
    },
    on: {
      "pick": _vm.handleTimePick
    }
  }) : _vm._e()], 1)]) : _vm._e(), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.currentView !== "time",
      expression: "state.currentView !== 'time'"
    }],
    staticClass: "xm-date-picker__header",
    class: {
      "xm-date-picker__header--bordered": ["month", "year", "years", "yearrange"].includes(_vm.state.currentView)
    }
  }, [_c("button", {
    staticClass: "xm-picker-panel__icon-btn xm-date-picker__prev-btn xm-icon-d-arrow-left",
    attrs: {
      "type": "button",
      "aria-label": _vm.t("ui.datepicker.prevYear")
    },
    on: {
      "click": _vm.cusPrevYear
    }
  }, [_c("icon-double-left")], 1), _c("button", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.currentView === "date",
      expression: "state.currentView === 'date'"
    }],
    staticClass: "xm-picker-panel__icon-btn xm-date-picker__prev-btn xm-icon-arrow-left",
    attrs: {
      "type": "button",
      "aria-label": _vm.t("ui.datepicker.prevMonth")
    },
    on: {
      "click": _vm.cusPrevMonth
    }
  }, [_c("icon-chevron-left")], 1), _c("span", {
    staticClass: "xm-date-picker__header-label",
    attrs: {
      "role": "button"
    },
    on: {
      "click": _vm.showYearPicker
    }
  }, [_vm._v(_vm._s(_vm.state.yearLabel))]), _c("span", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.currentView === "date",
      expression: "state.currentView === 'date'"
    }],
    staticClass: "xm-date-picker__header-label",
    class: {
      active: _vm.state.currentView === "month"
    },
    attrs: {
      "role": "button"
    },
    on: {
      "click": _vm.showMonthPicker
    }
  }, [_vm._v(_vm._s(_vm.t("ui.datepicker.month" + (_vm.state.month + 1))))]), _c("button", {
    staticClass: "xm-picker-panel__icon-btn xm-date-picker__next-btn xm-icon-d-arrow-right",
    attrs: {
      "type": "button",
      "aria-label": _vm.t("ui.datepicker.nextYear")
    },
    on: {
      "click": _vm.cusNextYear
    }
  }, [_c("icon-double-right")], 1), _c("button", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.currentView === "date",
      expression: "state.currentView === 'date'"
    }],
    staticClass: "xm-picker-panel__icon-btn xm-date-picker__next-btn xm-icon-arrow-right",
    attrs: {
      "type": "button",
      "aria-label": _vm.t("ui.datepicker.nextMonth")
    },
    on: {
      "click": _vm.cusNextMonth
    }
  }, [_c("icon-chevron-right")], 1)]), _c("div", {
    staticClass: "xm-picker-panel__content"
  }, [_vm.state.currentView === "date" ? _c("date-table", {
    ref: "dateTable",
    attrs: {
      "selection-mode": _vm.state.selectionMode,
      "first-day-of-week": _vm.state.firstDayOfWeek,
      "value": _vm.state.value,
      "default-value": _vm.state.defaultValue ? new Date(_vm.state.defaultValue) : null,
      "date": _vm.state.date,
      "cell-class-name": _vm.state.cellClassName,
      "disabled-date": _vm.state.disabledDate,
      "show-week-number": _vm.showWeekNumber,
      "format-weeks": _vm.formatWeeks
    },
    on: {
      "pick": _vm.handleDatePick
    }
  }) : _vm._e(), ["year", "years", "yearrange"].includes(_vm.state.currentView) ? _c("year-table", {
    ref: "yearTable",
    attrs: {
      "value": _vm.state.value,
      "default-value": _vm.state.defaultValue ? new Date(_vm.state.defaultValue) : null,
      "date": _vm.state.date,
      "disabled-date": _vm.state.disabledDate,
      "selection-mode": _vm.state.selectionMode,
      "start-year": _vm.state.startYear
    },
    on: {
      "pick": _vm.handleYearPick
    }
  }) : _vm._e(), _vm.state.currentView === "month" ? _c("month-table", {
    ref: "monthTable",
    attrs: {
      "value": _vm.state.value,
      "default-value": _vm.state.defaultValue ? new Date(_vm.state.defaultValue) : null,
      "date": _vm.state.date,
      "disabled-date": _vm.state.disabledDate
    },
    on: {
      "pick": _vm.handleMonthPick
    }
  }) : _vm._e()], 1)])], 2), _vm.state.isShowTz || _vm.state.timezone.isServiceTimezone ? _c("div", {
    directives: [{
      name: "clickoutside",
      rawName: "v-clickoutside",
      value: _vm.handleTzPickClose,
      expression: "handleTzPickClose"
    }],
    staticClass: "xm-picker-panel__timezone"
  }, [_c("xm-input", {
    attrs: {
      "disabled": _vm.state.timezone.isServiceTimezone,
      "placeholder": _vm.t("ui.datepicker.timezone")
    },
    on: {
      "update:modelValue": _vm.searchTz
    },
    scopedSlots: _vm._u([{
      key: "suffix",
      fn: function fn() {
        return [_c(_vm.state.showpopup ? "IconChevronDown" : "IconChevronUp", {
          tag: "component",
          attrs: {
            "fill": "#ccc"
          },
          on: {
            "click": _vm.toggleTz
          }
        })];
      },
      proxy: true
    }], null, false, 3034754380),
    model: {
      value: _vm.state.tz,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "tz", $$v);
      },
      expression: "state.tz"
    }
  }), _c("div", {
    staticClass: "xm-picker-panel__tzlist"
  }, [_c("xm-popup", {
    attrs: {
      "overlay": false,
      "position": "up",
      "duration": 0.2,
      "closeable": false
    },
    model: {
      value: _vm.state.showpopup,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "showpopup", $$v);
      },
      expression: "state.showpopup"
    }
  }, [_c("div", {
    staticClass: "tzlist"
  }, [_c("ul", _vm._l(_vm.state.renderTzdata, function(tz, index) {
    return _c("li", {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: !tz.visible,
        expression: "!tz.visible"
      }],
      key: index,
      staticClass: "xm-picker-panel__tzlist-li",
      attrs: {
        "title": tz.name
      },
      on: {
        "click": function click($event) {
          return _vm.selectTz(tz);
        }
      }
    }, [_vm._v(" " + _vm._s(tz.name) + " ")]);
  }), 0)])])], 1)], 1) : _vm._e(), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.isShowFooter,
      expression: "state.isShowFooter"
    }],
    staticClass: "xm-picker-panel__footer"
  }, [_c("xm-button", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !["dates", "years"].includes(_vm.state.selectionMode),
      expression: "!['dates', 'years'].includes(state.selectionMode)"
    }],
    staticClass: "xm-picker-panel__link-btn",
    attrs: {
      "size": "mini",
      "type": "text"
    },
    on: {
      "click": _vm.changeToNow
    }
  }, [_vm._v(" " + _vm._s(_vm.t("ui.datepicker.now")) + " ")]), _c("xm-button", {
    staticClass: "xm-picker-panel__link-btn",
    attrs: {
      "type": "primary",
      "size": "mini"
    },
    on: {
      "click": _vm.confirm
    }
  }, [_vm._v(" " + _vm._s(_vm.t("ui.datepicker.confirm")) + " ")])], 1)])]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var DatePanel = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
DatePanel.install = function(Vue) {
  Vue.component(DatePanel.name, DatePanel);
};
DatePanel.version = version;
export {
  DatePanel as default
};
